//<editor-fold defaultstate="collapsed" desc=" COPYRIGHT AND LICENSE ">
/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.geometries.viewer3d.controls.light_editor;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import javax.swing.BorderFactory;
import javax.swing.GroupLayout;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.jogamp.vecmath.Point3f;
import org.visnow.vn.geometries.viewer3d.lights.EditablePointLight;
import org.visnow.vn.geometries.viewer3d.lights.PointLightObject;

/**
 *
 * @author know
 */
public class AttenuationEditor extends javax.swing.JPanel
{
    private PointLightObject lightObject;
    private EditablePointLight light;
    private float attenuation = 1;
    private Color basicColor = new Color(.5f,.5f,.5f);

    /**
     * Creates new form AttenuationEditor
     */
    public AttenuationEditor()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        GridBagConstraints gridBagConstraints;

        displayPanel = new JPanel()
        {
            @Override
            public void paint(Graphics gr)
            {
                int w = getWidth();
                int h = getHeight();
                for (int i = w + h; i >= 0; i--)
                {
                    float a = 1 / (1 + (i * attenuation) / (2 * w) + (i * i * attenuation) / (4 * w * w));
                    int r = (int) (a * basicColor.getRed());
                    if (r > 255)
                    r = 255;
                    int g = (int) (a * basicColor.getGreen());
                    if (g > 255)
                    g = 255;
                    int b = (int) (a * basicColor.getBlue());
                    if (b > 255)
                    b = 255;
                    gr.setColor(new Color(r, g, b));
                    gr.fillArc(w / 2 - i / 2, h / 2 - i / 2, i, i, 0, 360);
                }
            }
        };
        attenuationSlider = new JSlider();

        setBorder(BorderFactory.createTitledBorder("Attenuation (light range)"));
        setLayout(new GridBagLayout());

        GroupLayout displayPanelLayout = new GroupLayout(displayPanel);
        displayPanel.setLayout(displayPanelLayout);
        displayPanelLayout.setHorizontalGroup(displayPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGap(0, 237, Short.MAX_VALUE)
        );
        displayPanelLayout.setVerticalGroup(displayPanelLayout.createParallelGroup(GroupLayout.Alignment.LEADING)
            .addGap(0, 43, Short.MAX_VALUE)
        );

        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(displayPanel, gridBagConstraints);

        attenuationSlider.addChangeListener(new ChangeListener()
        {
            public void stateChanged(ChangeEvent evt)
            {
                attenuationSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(attenuationSlider, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void attenuationSliderStateChanged(ChangeEvent evt)//GEN-FIRST:event_attenuationSliderStateChanged
    {//GEN-HEADEREND:event_attenuationSliderStateChanged
        setAttenuation(5 - attenuationSlider.getValue() / 20.f);
        if (lightObject != null)
            lightObject.setAttenuationCoefficient(attenuation);
    }//GEN-LAST:event_attenuationSliderStateChanged

    public void setLight(PointLightObject lightObject)
    {
        this.lightObject = lightObject;
        light = lightObject.getLight();
        setAttenuation(lightObject.getAttenuationCoefficient());
        setBasicColor(BrightColor.bright(light.getLightColor()));
    }

    private void setAttenuation(float attenuation)
    {
        this.attenuation = attenuation;
        displayPanel.repaint();
    }

    public void setBasicColor(Color color)
    {
        basicColor = color;
        displayPanel.repaint();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private JSlider attenuationSlider;
    private JPanel displayPanel;
    // End of variables declaration//GEN-END:variables
}
